﻿/*
    unFormatClipboardText
    Copyright (C) 2014 - 2016 Michael Albert <info@michlstechblog.info>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Security.AccessControl;

namespace info.michlstechblog.unformatClipboardText
{
    class Logging
    {
        public class FunctionReturn
        {
            public FunctionReturn(bool Success,string ErrorMessage)
            {
                this.Success = Success;
                this.ErrorMessage = ErrorMessage;
            }
            public FunctionReturn(bool Success)
            {
                this.Success = Success;
                this.ErrorMessage = "";
            }
            public bool Success { get; set; }
            public string ErrorMessage  { get; set; }
        }
        public FileStream oFileStream;
        public System.IO.StreamWriter oStream;
        private string sLogfile = "";
        public string LogFile
        {
            get
            {
                return (this.sLogfile);
            }
            set
            {
                string sOld = this.sLogfile;
                this.sLogfile = value;
                LogFileChangedEventArgs EventArgsLogFileChg = new LogFileChangedEventArgs();
                EventArgsLogFileChg.Logfile = LogFile;
                EventArgsLogFileChg.OldLogfile = sOld;
                LogFileChanged(EventArgsLogFileChg);
            }
        }
        public string LogfileContent(int Size)
        {

                if (File.Exists(sLogfile))
                {
                    // return ((new System.IO.StreamReader(new FileStream(sLogfile, FileMode.Open, FileAccess.Read, FileShare.ReadWrite, 8, FileOptions.None), Encoding.UTF8)).ReadToEnd());
                    //int iMaxReadBytes=
                    int sStartByte = 0;
                    int sReadBytes = Size;
                    FileStream oFileStream=new FileStream(sLogfile, FileMode.Open, FileAccess.Read, FileShare.ReadWrite, 8, FileOptions.None);
                    byte[] aReadBytes = new byte[Size];
                    if (oFileStream.Length < Size)
                    {
                        // Only even size
                        sReadBytes = (int)oFileStream.Length;
                    }
                    else
                    {
                        sStartByte = (int)oFileStream.Length - Size-1;
                    }
                    try 
                    {
                        //oFileStream.Read(aReadBytes, sStartByte, sReadBytes);
                        oFileStream.Seek(sStartByte, SeekOrigin.Begin);
                        oFileStream.Read(aReadBytes, 0, sReadBytes);
                        oFileStream.Close();
                        return(System.Text.Encoding.UTF8.GetString(aReadBytes));
                    }
                    catch(Exception Ex)
                    {
                        return ("Error occured while reading " +  sLogfile+". Error:"+Ex.Message);
                    }
                    // return ((new System.IO.StreamReader(new FileStream(sLogfile, FileMode.Open, FileAccess.Read, FileShare.ReadWrite, 8, FileOptions.None), Encoding.UTF8)).ReadToEnd());
                }
                else
                    return ("File " + sLogfile + " not found");

        }
        public bool OverwriteOnOpen{
            get;set;
        }
        public Logging(string Logfile, bool OverwriteFile)
        {
            this.OverwriteOnOpen = OverwriteFile;
            this.sLogfile = Logfile;
            // sLogFile
        }
        public FunctionReturn WriteLine2LogFile(string Line)
        {
            if (oStream != null)
            {
                try
                {
                    oStream.WriteLine(DateTime.Now.ToString("yyyyMMdd HH:mm:ss") +" | "+ Line);
                    oStream.Flush();
                    LogFileContentChangedEventArgs EventArgsLogFileContentChg = new LogFileContentChangedEventArgs();
                    EventArgsLogFileContentChg.Logfile = LogFile;
                    LogFileContentChanged(EventArgsLogFileContentChg);
                    return new FunctionReturn(true);
                }
                catch (Exception ex)
                {
                    CloseLogFile();
                    return new FunctionReturn(false, ex.Message);
                }
            }
            else
            {
                return new FunctionReturn(false, "Logfile " + this.LogFile + " not open");
            }
        }
        public FunctionReturn OpenLogFile()
        {
            try
            {
                if (oStream != null)
                    CloseLogFile();
                if(OverwriteOnOpen)
                {
                    oFileStream = new FileStream(sLogfile, FileMode.Create, FileAccess.Write, FileShare.ReadWrite, 8, FileOptions.WriteThrough);
                }
                else
                {
                    oFileStream = new FileStream(sLogfile, FileMode.Append, FileAccess.Write, FileShare.ReadWrite, 8, FileOptions.WriteThrough);
                    // oFileStream = new FileStream(sLogfile, FileMode.Append, FileSystemRights.Modify | FileSystemRights.Read | FileSystemRights.Write | FileSystemRights.AppendData | FileSystemRights.CreateFiles, FileShare.Read, 8, FileOptions.WriteThrough);
                }
                // oStream = new System.IO.StreamWriter(oFileStream, Encoding.UTF8);
                oStream = new System.IO.StreamWriter(oFileStream, new System.Text.UTF8Encoding(false));
                WriteLine2LogFile("----------------- Open log file ----------------------");
                oStream.Flush();
                return new FunctionReturn(true);
            }
            catch (Exception ex)
            {
                oStream = null;                        
                return new FunctionReturn(false,ex.Message);
            }
        }
        public FunctionReturn CloseLogFile()
        {
            try
            {
                if (oStream != null)
                {
                    WriteLine2LogFile("----------------- Close log file ---------------------");
                    oStream.Close();
                }
                if (oFileStream != null)
                    oFileStream.Close();
                return new FunctionReturn(true);
            }
            catch (Exception ex)
            {
                return new FunctionReturn(false, ex.Message);
            }
        }
        protected virtual void LogFileContentChanged(LogFileContentChangedEventArgs e)
        {
            EventHandler<LogFileContentChangedEventArgs> handler = OnLogFileContentChanged;
            if (handler != null)
            {
                handler(this, e);
            }
        }
        public event EventHandler<LogFileContentChangedEventArgs> OnLogFileContentChanged;
        public class LogFileContentChangedEventArgs : EventArgs
        {
            public String Logfile { get; set; }
        }
        protected virtual void LogFileChanged(LogFileChangedEventArgs e)
        {
            EventHandler<LogFileChangedEventArgs> handler = OnLogFileChanged;
            if (handler != null)
            {
                handler(this, e);
            }
        }
        public event EventHandler<LogFileChangedEventArgs> OnLogFileChanged;
        public class LogFileChangedEventArgs : EventArgs
        {
            public String Logfile { get; set; }
            public String OldLogfile { get; set; }
        }
    }
}
